var i;
var customKey;

customKey = self.options.withKey;

function keyboardModule( onUpdate ) {
  var kb = {};

  document.onkeydown = function( e ) {
    var key = e.charCode ? e.charCode : e.keyCode;
    kb[key] = true;
    if ( onUpdate ) {
      onUpdate( kb );
    }
  }

  document.onkeyup = function( e ) {
    var key = e.charCode ? e.charCode : e.keyCode;
    delete kb[key];
    if ( onUpdate ) {
      onUpdate( kb );
    }
  }

  return kb;
}

function testing( kb ) {
  showButtons();
}

var keyboard = keyboardModule( testing );
var mouseOk = false;

function showButtons() {
  var div;

  if ( mouseOk && 
       ( customKey < 0 ||
	 ( customKey == 0 && keyboard['17'] ) ||
	 ( customKey == 1 && keyboard['18'] ) ||
	 ( customKey == 2 && keyboard['17'] && keyboard['18'] ) ||
	 ( customKey == 3 && keyboard['16'] ) ) ) {
    div = document.getElementById( 'jdpre' );
    div.style.display = '';
    div = document.getElementById( 'jdopacity' );
    div.style.display = '';
  }
}

function hideButtons() {
  var div;

  if ( !mouseOk ) {
    div = document.getElementById( 'jdpre' );
    div.style.display = 'none';
    div = document.getElementById( 'jdopacity' );
    div.style.display = 'none';
  }
}

var jdpre, div;

jdpre = document.createElement( 'div' );
jdpre.style.zIndex = 1000;
jdpre.style.position = 'absolute';
jdpre.id = 'jdpre';
jdpre.style.display = 'none';
jdpre.onmouseout = function() {
  mouseOk = false;
  setTimeout( function () { hideButtons() }, 500 );
};
jdpre.onmouseover = function() {
  mouseOk = true;
};
document.body.appendChild( jdpre );
if ( self.options.simpleStorage.storage.devices && self.options.showButtons ) {
  var img, b, device;

  for( i=0; i<self.options.simpleStorage.storage.devices.length; i++ ) {
    device = self.options.simpleStorage.storage.devices[i];
    div = document.createElement( 'div' );
    div.style.background = '#D0D0D0';
    div.style.cssFloat = 'right';
    div.style.display = 'inline';
    div.style.cursor = 'pointer';
    div.style.margin = '5px';
    div.setAttribute( 'data-id', device.id );
    div.onmouseover = function() {
      mouseOk = true;
    };
    jdpre.appendChild( div );
    if ( device.icon != 0 ) {
      img = document.createElement( 'img' );
      if ( !self.options.showIcons ) {
	img.style.display = 'none';
      }
      img.src = self.options.icons[device.icon - 1];
      img.width = 24;
      img.height = 24;
      img.onmouseover = function() {
	mouseOk = true;
      };
      div.appendChild( img );
    }
    b = document.createElement( 'b' );
    b.style.verticalAlign = '25%';
    if ( !self.options.showLabel ) {
      b.style.display = 'none';
    }
    b.onmouseover = function() {
      mouseOk = true;
    };
    b.textContent = device.name;
    div.appendChild( b );
  }
}
div = document.createElement( 'div' );
div.style.zIndex = 999;
div.style.position = 'absolute';
div.style.background = '#AAAAAA';
div.style.verticalAlign = 'bottom';
div.style.opacity = 0.25;
div.id = 'jdopacity';
div.style.display = 'none';
document.body.appendChild( div );
div = document.createElement( 'div' );
div.style.display = 'none';
div.id = 'jdcontent';
document.body.appendChild( div );

if ( self.options.simpleStorage.storage.devices && self.options.showButtons ) {
  var elements;

  elements = document.getElementsByTagName( 'pre' );
  for( i=0; i<elements.length; i++ ) {
    elements[i].onmouseout = function () {
      mouseOk = false;
    };
    elements[i].onmouseover = function () {
      var div, rect, bodyRect, style, top, left;
      
      bodyRect = document.body.getBoundingClientRect(),
      rect = this.getBoundingClientRect();
      style = window.getComputedStyle( document.body );
      top = 0;
      left = 0;
      if ( style.margin ) {
	top += parseInt( style.margin.replace( /px/g, '' ) );
	left += parseInt( style.maring.replace( /px/g, '' ) );
      }
      if ( style.marginTop ) {
	top += parseInt( style.marginTop.replace( /px/g, '' ) );
      }
      if ( style.marginLeft ) {
	left += parseInt( style.marginLeft.replace( /px/g, '' ) );
      }
      div = document.getElementById( 'jdpre' );
      div.style.top = ( rect.top - bodyRect.top + top ) + 'px';
      div.style.left = ( rect.left - bodyRect.left + left ) + 'px';
      div.style.width = ( rect.right - rect.left ) + 'px';
      div.style.height = ( rect.bottom - rect.top ) + 'px';
      div = document.getElementById( 'jdopacity' );
      div.style.top = ( rect.top - bodyRect.top + top ) + 'px';
      div.style.left = ( rect.left - bodyRect.left + left ) + 'px';
      div.style.width = ( rect.right - rect.left ) + 'px';
      div.style.height = ( rect.bottom - rect.top ) + 'px';
      document.getElementById( 'jdcontent' ).textContent = this.innerHTML;
      mouseOk = true;
      showButtons();
    };
  }
}

document.getElementById( 'jdpre' ).addEventListener( 'click', function( event ) {
  var t = event.target;

  if ( t.nodeName == 'DIV' )
    if ( t.hasAttribute( 'data-id' ) ) {
      self.port.emit( 'click', t.getAttribute( 'data-id' ), document.getElementById( 'jdcontent' ).innerHTML );
      event.stopPropagation();
      event.preventDefault();
    }
  if ( t.nodeName == 'IMG' || t.nodeName == 'B' )
    if ( t.parentNode.nodeName == 'DIV' && t.parentNode.hasAttribute( 'data-id' ) ) {
      self.port.emit( 'click', t.parentNode.getAttribute( 'data-id' ), document.getElementById( 'jdcontent' ).innerHTML );
      event.stopPropagation();
      event.preventDefault();
    }
}, false );
