
window.addEventListener( 'click', function( event ) {
  var t = event.target;

  if ( t.nodeName == 'LI' )
    if ( t.hasAttribute( 'data-url' ) )
      self.port.emit( 'click-link', t.getAttribute( 'data-url' ) );
  if ( t.nodeName == 'TD' )
    if ( t.hasAttribute( 'data-id' ) )
      self.port.emit( 'click-device', t.getAttribute( 'data-id' ) );
  if ( t.nodeName == 'IMG' || t.nodeName == 'B' )
    if ( t.parentNode.nodeName == 'TD' && t.parentNode.className == 'device select' && t.parentNode.hasAttribute( 'data-id' ) )
      self.port.emit( 'click-device', t.parentNode.getAttribute( 'data-id' ) );
}, false );

self.port.on( 'show', function onShow( simpleStorage, selection ) {
  var div, table, tr, td, img, b;

  div = document.getElementById( 'devices' );
  while ( div.firstChild ) {
    div.removeChild( div.firstChild );
  }
  table = document.createElement( 'table' );
  tr = document.createElement( 'tr' );
  table.appendChild( tr );
  if ( simpleStorage.storage.devices ) {
    for( i=0; i<simpleStorage.storage.devices.length; i++ ) {
      td = document.createElement( 'td' );
      td.className = 'device';
      if ( selection ) {
	td.className += ' select';
      } else {
	td.className += ' unselected';
      }
      td.setAttribute( 'data-id', simpleStorage.storage.devices[i].id );
      tr.appendChild( td );
      switch( parseInt( simpleStorage.storage.devices[i].icon ) ) {
      case 1:
	img = document.createElement( 'img' );
	img.src = 'smartphone.png';
	img.width = 48;
	img.height = 48;
	td.appendChild( img );
	td.appendChild( document.createElement( 'br' ) );
	break;
      case 2:
	img = document.createElement( 'img' );
	img.src = 'tablet.png';
	img.width = 48;
	img.height = 48;
	td.appendChild( img );
	td.appendChild( document.createElement( 'br' ) );
	break;
      case 3:
	img = document.createElement( 'img' );
	img.src = 'computer.png';
	img.width = 48;
	img.height = 48;
	td.appendChild( img );
	td.appendChild( document.createElement( 'br' ) );
	break;
      case 4:
	img = document.createElement( 'img' );
	img.src = 'phablet.png';
	img.width = 48;
	img.height = 48;
	td.appendChild( img );
	td.appendChild( document.createElement( 'br' ) );
	break;
      }
      b = document.createElement( 'b' );
      b.textContent = simpleStorage.storage.devices[i].name;
      td.appendChild( b );
    }
  }
  div.appendChild( table );
} );
